
// AI N SamplesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AI N Samples.h"
#include "AI N SamplesDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()



CAINSamplesDlg::CAINSamplesDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CAINSamplesDlg::IDD, pParent)
	, SampleRate(100000)
	, PtsPerChan(1000)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAINSamplesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_DeviceIndex, mDeviceIndexCombo);
	DDX_Control(pDX, IDC_COMBO_AiRange, mAiRangeCombo);
	DDX_Text(pDX, IDC_EDIT1, SampleRate);
	DDX_Control(pDX, IDC_COMBO_ChanMode, mChanModeCombo);
	DDX_Text(pDX, IDC_EDIT_PtsPerChan, PtsPerChan);
	DDX_Check(pDX, IDC_CHECK_AI_0, ChanSel_Ai[0]);
	DDX_Check(pDX, IDC_CHECK_AI_1, ChanSel_Ai[1]);
	DDX_Check(pDX, IDC_CHECK_AI_2, ChanSel_Ai[2]);
	DDX_Check(pDX, IDC_CHECK_AI_3, ChanSel_Ai[3]);
	DDX_Check(pDX, IDC_CHECK_AI_4, ChanSel_Ai[4]);
	DDX_Check(pDX, IDC_CHECK_AI_5, ChanSel_Ai[5]);
	DDX_Check(pDX, IDC_CHECK_AI_6, ChanSel_Ai[6]);
	DDX_Check(pDX, IDC_CHECK_AI_7, ChanSel_Ai[7]);
	DDX_Check(pDX, IDC_CHECK_AI_8, ChanSel_Ai[8]);
	DDX_Check(pDX, IDC_CHECK_AI_9, ChanSel_Ai[9]);
	DDX_Check(pDX, IDC_CHECK_AI_10, ChanSel_Ai[10]);
	DDX_Check(pDX, IDC_CHECK_AI_11, ChanSel_Ai[11]);
	DDX_Check(pDX, IDC_CHECK_AI_12, ChanSel_Ai[12]);
	DDX_Check(pDX, IDC_CHECK_AI_13, ChanSel_Ai[13]);
	DDX_Check(pDX, IDC_CHECK_AI_14, ChanSel_Ai[14]);
	DDX_Check(pDX, IDC_CHECK_AI_15, ChanSel_Ai[15]);
	DDX_Control(pDX, IDC_LIST3, mDataListCtrl);
}

BEGIN_MESSAGE_MAP(CAINSamplesDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_Start, &CAINSamplesDlg::OnBnClickedButtonStart)
END_MESSAGE_MAP()



BOOL CAINSamplesDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		

	long CardCount;
	CardCount = FindUSBDAQ();		//  represents the quantity of the detected specific cards in the system
	
	long i;
	CString a;
	char b[6];
	for(i = 0; i < CardCount; i++)
	{
		a = _T("");
		ltoa(i, b, 1);
		a = a + b[0];
		mDeviceIndexCombo.AddString(a);
	}

	mDeviceIndexCombo.SetCurSel(0);
	mAiRangeCombo.SetCurSel(0);
	mChanModeCombo.SetCurSel(1);
	ChanSel_Ai[0] = 1;
	ChanSel_Ai[1] = 1;

	UpdateData(false);

	return TRUE;  
}

void CAINSamplesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}


void CAINSamplesDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

HCURSOR CAINSamplesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CAINSamplesDlg::OnBnClickedButtonStart()
{
	int i;
	int j;
	int temp;
	CString s;
	float data[500000];

	UpdateData(true);

	DeviceIndex = mDeviceIndexCombo.GetCurSel();	
	temp = OpenDevice(DeviceIndex);					//  Open the DAQ card. No need to change the parameter.
	temp = ResetDevice(DeviceIndex);				// ResetDevice
	
	if(mAiRangeCombo.GetCurSel() == 0)
	{
		AiRange = 5;
	}
	else
	{
		AiRange = 10;
	}
	temp = SetUSB1AiRange(DeviceIndex, AiRange);	//  Set range, with the last parameter as the range, which can be set as 10, 5
	temp = SetSampleRate(DeviceIndex, SampleRate);	//  Set sampling rate, with the last parameter as the sampling rate.

	switch(mChanModeCombo.GetCurSel())
	{
		case 0: // NRSE
			ChanMode = 1;
		case 1: // DIFF
			ChanMode = 0;
		case 2:	// RSE
			ChanMode = 3;
	}
	temp = SetChanMode(DeviceIndex, ChanMode);		// Set channel mode
	
	ChansCount = 0;
	for(i = 0; i < 16; i++)
	{
		ChanSel = ChanSel << 1;
		ChanSel = ChanSel + ChanSel_Ai[15 - i];
		if(ChanSel_Ai[i] == 1)
		{
			ChansCount = ChansCount + ChanSel_Ai[i];
		}
	}
	temp = SetChanSel(DeviceIndex, ChanSel);		// Set the channel to acquire. Each bit of the binary represents a channel, with 1 meaning to load, 0 meaning to not load. For channel 0 to be loaded, set to 1; for channel 0 and 2 to be loaded, set to 5. When set to 255, channel 0 to 7 will be all loaded.

	temp = StartRead(DeviceIndex);					// Start data reading thread. No need to change the parameter.
	temp = SetSoftTrig(DeviceIndex, 1);				// Set it as software trigger and start the data acquisition. No need to change the parameter.

		//  Load data. PtsPerChan represents the points to load for every channel.
		// Set the channel to load. Each bit of the binary represents a channel, with 1 meaning to load, 0 meaning to not load. For channel 0 to be loaded, set to 1; for channel 0 and 2 to be loaded, set to 5. When set to 255, channel 0 to 7 will be all loaded.
		// The size of the Data array is the result of the number of points read per channel by the number of read channels. In this example, 8 channels are read, each channel reads NumToRead points, and the size of Data is NumToRead * 8.
		// 2000 is the timeout setting, meaning if no data is read within 2000ms, it will quit the function.
		// If continuous data acquisition is required, then loop execute the GetAiChans function and process the data in the loop.
	temp =GetAiChans(DeviceIndex, PtsPerChan, ChanSel, data, 1000);

	temp = StopRead(DeviceIndex);					// Stop the data acquisition thread
	temp = SetSoftTrig(DeviceIndex, 0);				// Turn off software trigger
	temp = ClearBufs(DeviceIndex);					// Wipe the data in buffer
	temp = StartCounter(DeviceIndex, 0x0f, 0);		// Turn off Counter
	CloseDevice(DeviceIndex);						// Close device

	while(mDataListCtrl.DeleteColumn(0))
	{
		mDataListCtrl.DeleteAllItems();
	}

	for(i = 0; i < ChansCount + 1; i++)
	{
		mDataListCtrl.InsertColumn(i, _T(""), LVCFMT_RIGHT, 80);
	}

	for(i = 0; i < PtsPerChan; i++)
	{
		s.Format(_T("%d"), i);
		mDataListCtrl.InsertItem(i, s);
		for(j = 0; j < ChansCount; j++)
		{
			s.Format(_T("%f"), data[j * PtsPerChan + i]);
			mDataListCtrl.SetItemText(i, j + 1, s);
		}
	}
	
	UpdateData(false);
}
