
// CounterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Counter.h"
#include "CounterDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif



class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()





CCounterDlg::CCounterDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CCounterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCounterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_DeviceIndex, mDeviceIndexCombo);
	DDX_Control(pDX, IDC_COMBO_CtrMode, mCtrModeCombo);
	DDX_Control(pDX, IDC_COMBO_CounterEdge, mCtrEdgeCombo);
	DDX_Control(pDX, IDC_BUTTON1, mStartBtn);
	DDX_Control(pDX, IDC_BUTTON2, mStopBtn);
	DDX_Text(pDX, IDC_EDIT1, CT[0]);
	DDX_Text(pDX, IDC_EDIT2, CT[1]);
	DDX_Text(pDX, IDC_EDIT3, CT[2]);
	DDX_Text(pDX, IDC_EDIT4, CT[3]);
	DDX_Control(pDX, IDCANCEL, mExitBtn);
}

BEGIN_MESSAGE_MAP(CCounterDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CCounterDlg::OnBnClickedButton1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON2, &CCounterDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDCANCEL, &CCounterDlg::OnBnClickedCancel)
END_MESSAGE_MAP()



BOOL CCounterDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		

	long CardCount;
	CardCount = FindUSBDAQ();		//  represents the quantity of the detected specific cards in the system
	
	if(CardCount > 0)
	{
		mStartBtn.EnableWindow(1);
	}
	else
	{
		mStartBtn.EnableWindow(0);
	}
	
	mStopBtn.EnableWindow(0);

	long i;
	CString a;
	char b[6];
	for(i = 0; i < CardCount; i++)
	{
		a = _T("");
		ltoa(i, b, 1);
		a = a + b[0];
		mDeviceIndexCombo.AddString(a);
	}

	for(i = 0; i < 4; i++)
	{
		CT[i] = 0;
	}

	mDeviceIndexCombo.SetCurSel(0);
	mCtrModeCombo.SetCurSel(1);
	mCtrEdgeCombo.SetCurSel(0);

	running = false;
	UpdateData(false);
	return TRUE;  
}

void CCounterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}


void CCounterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;


		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}


HCURSOR CCounterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CCounterDlg::OnBnClickedButton1()
{
	int temp;
	unsigned char CtrMode;
	unsigned char CtrEdge;
	int i;

	UpdateData(true);

	CtrMode = mCtrModeCombo.GetCurSel();
	CtrEdge = mCtrEdgeCombo.GetCurSel() + 1;

	DeviceIndex = mDeviceIndexCombo.GetCurSel();	
	temp = OpenDevice(DeviceIndex);					//  Open the DAQ card. No need to change the parameter.
	temp = ResetDevice(DeviceIndex);				// ResetDevice
	temp = SetCounter(DeviceIndex, 0x0f, CtrMode, CtrEdge);	// Set channel mode
	temp = StartCounter(DeviceIndex, 0x0f, 1);		// Start counter
	temp = StartRead(DeviceIndex);					// Start data reading thread. No need to change the parameter.
	temp = TransDioIn(DeviceIndex, 1);				// Initiate Dioln data transfer

	SetTimer(1, 100, NULL);
	mStopBtn.EnableWindow(1);
	mStartBtn.EnableWindow(0);
	running = true;
}


void CCounterDlg::OnTimer(UINT_PTR nIDEvent)
{
	int temp;
	int i;

	UpdateData(true);

	if(nIDEvent == 1)
	{
		for(i = 0; i < 4; i++)
		{
			CT[i] = GetCounter(DeviceIndex, i);		// Load the value of 4 counters
		}
	}

	UpdateData(false);

	CDialogEx::OnTimer(nIDEvent);
}


void CCounterDlg::OnBnClickedButton2()
{

	int temp;

	KillTimer(1);
	Sleep(10);

	temp = TransDioIn(DeviceIndex, 0);			// Stop Dioln data transfer
	temp = StopRead(DeviceIndex);				// Stop the data acquisition thread
	temp = StartCounter(DeviceIndex, 0x0f, 0);	// Turn off Counter
	CloseDevice(DeviceIndex);					// Close device

	
	mStopBtn.EnableWindow(0);
	mStartBtn.EnableWindow(1);
	running = false;
}


void CCounterDlg::OnBnClickedCancel()
{
	int temp;

	if(running == true)
	{
		KillTimer(1);
		Sleep(10);

	temp = TransDioIn(DeviceIndex, 0);			// Stop Dioln data transfer
	temp = StopRead(DeviceIndex);				// Stop the data acquisition thread
	temp = StartCounter(DeviceIndex, 0x0f, 0);	// Turn off Counter
	CloseDevice(DeviceIndex);					// Close device

	
		mStopBtn.EnableWindow(0);
		mStartBtn.EnableWindow(1);
		running = false;
	}

	CDialogEx::OnCancel();
}
